# Datei zur Erstellung der Bibliotheksdateien

# Alle Variablen fuer Hauptpfade
OBJECT_FILE_PATH = $(OUTPUT_FOLDER)/
LIBRARY_FILE_PATH = $(OUTPUT_FOLDER)/

# Alle Variablen fuer Projektklassen
PROJECT_PATH = ./
PROJECT_SOURCES = \
$(PROJECT_PATH)AEChannelArray.cpp \
$(PROJECT_PATH)AEComm.cpp \
$(PROJECT_PATH)DatafoxCommIV.cpp \
$(PROJECT_PATH)stdafx.cpp 
PROJECT_FILES_CPP = $(notdir $(PROJECT_SOURCES))
PROJECT_FILES_O = $(addprefix $(OBJECT_FILE_PATH), $(PROJECT_FILES_CPP:.cpp=.o))
PROJECT_FILES_D = $(addprefix $(OBJECT_FILE_PATH), $(PROJECT_FILES_CPP:.cpp=.d))
ALL_FILES_O += $(PROJECT_FILES_O)
ALL_FILES_D += $(PROJECT_FILES_D)

# Variable f�r Include-Pfade
INCLUDE_PATH = $(PROJECT_PATH)
BOOST_PATH = $(PROJECT_PATH)../Shared/boost/

# Alle Variablen fuer Kommunikationsklassen
CHANNEL_PATH = ../Shared/Channel/
CHANNEL_SOURCES = \
$(CHANNEL_PATH)AEChannel.cpp \
$(CHANNEL_PATH)Channel1_2.cpp \
$(CHANNEL_PATH)Channel4.cpp \
$(CHANNEL_PATH)Channel4ModuleApplication.cpp \
$(CHANNEL_PATH)Channel4ModuleHardware.cpp \
$(CHANNEL_PATH)Channel4ModuleSystem.cpp \
$(CHANNEL_PATH)Channel4ModuleTable.cpp \
$(CHANNEL_PATH)Channel4Protocol.cpp \
$(CHANNEL_PATH)ChannelBase.cpp \
$(CHANNEL_PATH)TimeboyStation.cpp
CHANNEL_FILES_CPP = $(notdir $(CHANNEL_SOURCES))
CHANNEL_FILES_O = $(addprefix $(OBJECT_FILE_PATH), $(CHANNEL_FILES_CPP:.cpp=.o))
CHANNEL_FILES_D = $(addprefix $(OBJECT_FILE_PATH), $(CHANNEL_FILES_CPP:.cpp=.d))
ALL_FILES_O += $(CHANNEL_FILES_O)
ALL_FILES_D += $(CHANNEL_FILES_D)

# Alle Variablen fuer Allgemeines
COMMON_PATH = ../Shared/Common/
COMMON_SOURCES = \
$(COMMON_PATH)AEBuffer.cpp \
$(COMMON_PATH)ATmega.cpp \
$(COMMON_PATH)crc.cpp \
$(COMMON_PATH)DataFlash.cpp \
$(COMMON_PATH)DFComUtils.cpp \
$(COMMON_PATH)md5.cpp \
$(COMMON_PATH)DFSoftwareVersion.cpp
COMMON_FILES_CPP = $(notdir $(COMMON_SOURCES))
COMMON_FILES_O = $(addprefix $(OBJECT_FILE_PATH), $(COMMON_FILES_CPP:.cpp=.o))
COMMON_FILES_D = $(addprefix $(OBJECT_FILE_PATH), $(COMMON_FILES_CPP:.cpp=.d))
ALL_FILES_O += $(COMMON_FILES_O)
ALL_FILES_D += $(COMMON_FILES_D)

# Alle Variablen fuer Datafox Items
DFITEM_PATH = ../Shared/DFItem/
DFITEM_SOURCES = \
$(DFITEM_PATH)DFItemAccessControl.cpp \
$(DFITEM_PATH)DFItemAccessControl2.cpp \
$(DFITEM_PATH)DFItemBase.cpp \
$(DFITEM_PATH)DFItemDevice.cpp \
$(DFITEM_PATH)DFItemHandling.cpp \
$(DFITEM_PATH)DFItemInputChain.cpp \
$(DFITEM_PATH)DFItemInputChainField.cpp \
$(DFITEM_PATH)DFItemIOModule.cpp \
$(DFITEM_PATH)DFItemMDE.cpp \
$(DFITEM_PATH)DFItemMenu.cpp \
$(DFITEM_PATH)DFItemMenuChoice.cpp \
$(DFITEM_PATH)DFItemTable.cpp \
$(DFITEM_PATH)DFItemTableField.cpp \
$(DFITEM_PATH)DFItemTableList.cpp \
$(DFITEM_PATH)DFItemTableRecord.cpp 
DFITEM_FILES_CPP = $(notdir $(DFITEM_SOURCES))
DFITEM_FILES_O = $(addprefix $(OBJECT_FILE_PATH), $(DFITEM_FILES_CPP:.cpp=.o))
DFITEM_FILES_D = $(addprefix $(OBJECT_FILE_PATH), $(DFITEM_FILES_CPP:.cpp=.d))
ALL_FILES_O += $(DFITEM_FILES_O)
ALL_FILES_D += $(DFITEM_FILES_D)

# Alle Variablen fuer Datafox File Dateien
DFFILE_PATH = ../Shared/File/
DFFILE_SOURCES = \
$(DFFILE_PATH)DFFileDevice.cpp \
$(DFFILE_PATH)DFFileDeviceText.cpp \
$(DFFILE_PATH)DFFileDeviceZip.cpp \
$(DFFILE_PATH)DFFileDisplay.cpp \
$(DFFILE_PATH)DFFileIni.cpp \
$(DFFILE_PATH)DFFileIntelHex.cpp \
$(DFFILE_PATH)DFFileStudio.cpp \
$(DFFILE_PATH)DFFileStudioXML.cpp \
$(DFFILE_PATH)DFFileRawFirmware.cpp \
$(DFFILE_PATH)IniFile.cpp \
$(DFFILE_PATH)IntelHex.cpp \
$(DFFILE_PATH)DFFileTouchKeys.cpp \
$(DFFILE_PATH)DFFileDisplayColors.cpp 
DFFILE_FILES_CPP = $(notdir $(DFFILE_SOURCES))
DFFILE_FILES_O = $(addprefix $(OBJECT_FILE_PATH), $(DFFILE_FILES_CPP:.cpp=.o))
DFFILE_FILES_D = $(addprefix $(OBJECT_FILE_PATH), $(DFFILE_FILES_CPP:.cpp=.d))
ALL_FILES_O += $(DFFILE_FILES_O)
ALL_FILES_D += $(DFFILE_FILES_D)

# Alle Variablen fuer Log
DFLOG_PATH = ../Shared/Log/
DFLOG_SOURCES = \
$(DFLOG_PATH)DFLog.cpp \
$(DFLOG_PATH)DFLogCheck.cpp 
DFLOG_FILES_CPP = $(notdir $(DFLOG_SOURCES))
DFLOG_FILES_O = $(addprefix $(OBJECT_FILE_PATH), $(DFLOG_FILES_CPP:.cpp=.o))
DFLOG_FILES_D = $(addprefix $(OBJECT_FILE_PATH), $(DFLOG_FILES_CPP:.cpp=.d))
ALL_FILES_O += $(DFLOG_FILES_O)
ALL_FILES_D += $(DFLOG_FILES_D)

# Alle Variablen fuer TINYXML
TINYXML_PATH = ../Shared/tinyxml/
TINYXML_SOURCES = \
$(TINYXML_PATH)tinystr.cpp \
$(TINYXML_PATH)tinyxml.cpp \
$(TINYXML_PATH)tinyxmlerror.cpp \
$(TINYXML_PATH)tinyxmlparser.cpp 
TINYXML_FILES_CPP = $(notdir $(TINYXML_SOURCES))
TINYXML_FILES_O = $(addprefix $(OBJECT_FILE_PATH), $(TINYXML_FILES_CPP:.cpp=.o))
TINYXML_FILES_D = $(addprefix $(OBJECT_FILE_PATH), $(TINYXML_FILES_CPP:.cpp=.d))
ALL_FILES_O += $(TINYXML_FILES_O)
ALL_FILES_D += $(TINYXML_FILES_D)

# Alle Variablen fuer XMLRPC
XMLPRC_PATH = ../Shared/xmlrpc/

# Alle Variablen fuer ZIP Utils
ZIPUTILS_PATH = ../Shared/zip_utils/

# Static library
$(LIBRARY_FILE_PATH)DFCom.a: $(ALL_FILES_O)
	ar -cr $(LIBRARY_FILE_PATH)DFCom.a $(ALL_FILES_O)
	ranlib $(LIBRARY_FILE_PATH)DFCom.a

# shared library
#
# Benoetigt zum ausfuehren ggf. Umgebungsvariable: LD_LIBRARY_PATH
# Pruefen ob vorhanden: echo $LD_LIBRARY_PATH
# setzen wenn fehlt:
#    LD_LIBRARY_PATH=/full/path/to/library/directory
#    export LD_LIBRARY_PATH
# oder ergaenzen wenn vorhanden:
#    LD_LIBRARY_PATH=/full/path/to/library/directory:${LD_LIBRARY_PATH}
#    export LD_LIBRARY_PATH
$(LIBRARY_FILE_PATH)libDFCom.so: $(ALL_FILES_O)
	g++ -shared $(ALL_FILES_O) -o $(LIBRARY_FILE_PATH)libDFCom.so

# Fuer jedes Unterverzeichnis welches Quelltextdateien enthaelt wird ein separates target angelegt
$(OBJECT_FILE_PATH)%.o: $(PROJECT_PATH)%.cpp
	@echo 'Erstelle Datei: $<'
	g++ -I$(INCLUDE_PATH) -I$(BOOST_PATH) $(OPTIMIZE) $(DEBUGLEVEL) $(WARNLEVEL) -c -fmessage-length=0 -fPIC -MMD -MP -MF"$(@:%.o=%.d)" -MT"$(@:%.o=%.d)" -o"$@" "$<"
	@echo ' '

$(OBJECT_FILE_PATH)%.o: $(CHANNEL_PATH)%.cpp
	@echo 'Erstelle Datei: $<'
	g++ -I$(INCLUDE_PATH) $(OPTIMIZE) $(DEBUGLEVEL) $(WARNLEVEL) -c -fmessage-length=0 -fPIC -MMD -MP -MF"$(@:%.o=%.d)" -MT"$(@:%.o=%.d)" -o"$@" "$<"
	@echo ' '

$(OBJECT_FILE_PATH)%.o: $(COMMON_PATH)%.cpp
	@echo 'Erstelle Datei: $<'
	g++ -I$(INCLUDE_PATH) $(OPTIMIZE) $(DEBUGLEVEL) $(WARNLEVEL) -c -fmessage-length=0 -fPIC -MMD -MP -MF"$(@:%.o=%.d)" -MT"$(@:%.o=%.d)" -o"$@" "$<"
	@echo ' '

$(OBJECT_FILE_PATH)%.o: $(DFITEM_PATH)%.cpp
	@echo 'Erstelle Datei: $<'
	g++ -I$(INCLUDE_PATH) $(OPTIMIZE) $(DEBUGLEVEL) $(WARNLEVEL) -c -fmessage-length=0 -fPIC -MMD -MP -MF"$(@:%.o=%.d)" -MT"$(@:%.o=%.d)" -o"$@" "$<"
	@echo ' '

$(OBJECT_FILE_PATH)%.o: $(DFFILE_PATH)%.cpp
	@echo 'Erstelle Datei: $<'
	g++ -I$(INCLUDE_PATH) $(OPTIMIZE) $(DEBUGLEVEL) $(WARNLEVEL) -c -fmessage-length=0 -fPIC -MMD -MP -MF"$(@:%.o=%.d)" -MT"$(@:%.o=%.d)" -o"$@" "$<"
	@echo ' '

$(OBJECT_FILE_PATH)%.o: $(DFLOG_PATH)%.cpp
	@echo 'Erstelle Datei: $<'
	g++ -I$(INCLUDE_PATH) $(OPTIMIZE) $(DEBUGLEVEL) $(WARNLEVEL) -c -fmessage-length=0 -fPIC -MMD -MP -MF"$(@:%.o=%.d)" -MT"$(@:%.o=%.d)" -o"$@" "$<"
	@echo ' '

$(OBJECT_FILE_PATH)%.o: $(TINYXML_PATH)%.cpp
	@echo 'Erstelle Datei: $<'
	g++ -I$(INCLUDE_PATH) $(OPTIMIZE) $(DEBUGLEVEL) $(WARNLEVEL) -c -fmessage-length=0 -fPIC -MMD -MP -MF"$(@:%.o=%.d)" -MT"$(@:%.o=%.d)" -o"$@" "$<"
	@echo ' '
