/**
 * @file  AEChannelArray.h
 * @brief Schnittstelle fuer die Klasse CAEChannelArray.
 */
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AE3CHANNELARRAY_H__E3C45889_4BC1_4E74_9A5C_284BD5DD180D__INCLUDED_)
#define AFX_AE3CHANNELARRAY_H__E3C45889_4BC1_4E74_9A5C_284BD5DD180D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Kanal - Klasse einbinden
#include "AEChannel.h"

#define MAX_CHANNEL	                  251 // Maximalanzahl zu verwaltender Kanalklassen
#define MAX_CHANNEL4                   50 // Maximalanzahl zu verwaltender Kanalklassen fuer Verbindungsannahmen

// Verwalten der Kommunikationskanaele
class CAEChannelArray
{
public:
	CAEChannelArray();
	virtual ~CAEChannelArray();

	// Kanalarray ueber Indizierungsoperator verwalten
	CAEChannel* operator[](short channelID) const
		{ return m_channels[channelID]; }
	CAEChannel*& operator[](short channelID)
		{ return (CAEChannel*&)m_channels[channelID]; }

protected:
	CAEChannel *m_channels[MAX_CHANNEL];
};

// Verwalten der Kommunikationskanaele
class CChannel4Array
{
public:
	CChannel4Array();
	virtual ~CChannel4Array();

	// Kanalarray ueber Indizierungsoperator verwalten
	CChannel4* operator[](short channelID) const
		{ return m_channels[channelID]; }
	CChannel4*& operator[](short channelID)
		{ return (CChannel4*&)m_channels[channelID]; }

protected:
	CChannel4 *m_channels[MAX_CHANNEL4];
};

#endif // !defined(AFX_AE3CHANNELARRAY_H__E3C45889_4BC1_4E74_9A5C_284BD5DD180D__INCLUDED_)

